
#include "messageforwarder.h"

using namespace IRC;

MessageForwarder::MessageForwarder( QObject *parent, const char *name )
    : MessageDispatcher( parent, name )
{
}

void MessageForwarder::registerForwardMapping( const QString &key, int parameterIndex )
{
    m_forwardMapping[ key ] = parameterIndex;
}

void MessageForwarder::forwardMessage( const IRC::Message &msg )
{
    QString type = msg.type();
    ForwardingMap::ConstIterator forwardIt = m_forwardMapping.find( type );
    if ( forwardIt == m_forwardMapping.end() ) {
        emit unhandledMessage( msg );
        return;
    }

    QStringList keys = QStringList::split( ",", msg.parameter( *forwardIt ) );
    for ( QStringList::ConstIterator it = keys.begin();
          it != keys.end(); ++it )
        forwardMessage( *it, msg );
}

void MessageForwarder::forwardMessage( const QString &key, const IRC::Message &msg )
{
    dispatchMessage( key, msg );
}

#include "messageforwarder.moc"

/* vim: et sw=4 ts=4
 */
